#ifndef UpperTesterCODEC_H
#define UpperTesterCODEC_H

#include "Codec.hh"
#include "loggers.hh" // TODO To be removed
#include "Params.hh"

class Base_Type;
class Record_Type;
class TTCN_Typedescriptor_t;
class TTCN_Buffer;

namespace LibItsGeoNetworking__TestSystem {
  class UtInitialize;
}

class UpperTesterCodec: public Codec <
  Record_Type,
  Record_Type>
{
public:
  UpperTesterCodec() : Codec<Record_Type, Record_Type>() { loggers::get_instance().log("UpperTesterCodec::UpperTesterCodec(D)"); };
  virtual ~UpperTesterCodec() { loggers::get_instance().log("UpperTesterCodec::~UpperTesterCodec"); };

  virtual int encode (const Record_Type&, OCTETSTRING& data);
  virtual int decode (const OCTETSTRING& data, Record_Type&, Params* params = NULL);
};

#endif
